.nolist
#include <avr/io.h>
#include "param.h"
.list

.section .bss

XStart:		.ds.b	1
YCnt:		.ds.b	1
.extern IntCnt
.extern WriteRamPage
.extern DispRamPage
XsaveL:		.ds.b	1
XsaveH:		.ds.b	1
#ifdef GRAYSCALE
GrayCnt:	.ds.b	1
#endif


#ifdef GRAYSCALE
#ifdef GRAY8
#define XSIZEV	XVSIZESW/3
#else
#define XSIZEV	XVSIZESW/2
#endif
#else
#define XSIZEV	XVSIZESW
#endif

.section .text
#ifdef HWLP
.global TIMER1_OVF_vect
TIMER1_OVF_vect:
#else
.global TIMER0_COMP_vect
TIMER0_COMP_vect:
#endif
#ifdef TESTPULSE
	sbi _SFR_IO_ADDR(PORTB), 0
#endif
	push r16
	in r16, _SFR_IO_ADDR(SREG)
	push r16
	push XL
	push XH

	lds r16, DispRamPage			//Switch to Read Ram Page (Ram Page that will be displayed)
	out _SFR_IO_ADDR(PORTB), r16

	lds r16, IntCnt
	cpi r16, 1
	brlo load1of3
	breq load2of3
	rjmp load3of3

load1of3:
	ldi r16, 1
	sts IntCnt, r16

#ifndef HWLP
	sbi _SFR_IO_ADDR(PORTD), LP	// Latchpuls der vorherigen Daten (am Anfang des Interrupts, da hier der Jitter am geringsten ist)
#endif
#ifndef HWLP
	cbi _SFR_IO_ADDR(PORTD), LP
#endif

	lds r16, GrayCnt
	lds XH, YCnt			// Zeilenadresse laden
	cpi XH, YMin
	brne skipFirstlineoffset
	subi r16, 1
skipFirstlineoffset:
	subi r16, -3
	cpi r16, 7
	brlo skipgcovf
	subi r16, 7
skipgcovf:
	sts GrayCnt, r16

	clr XL
	sbrs r16, 1				//Wenn Bit0 = 0 wird Bild 0 (=MSB) angezeigt
	rjmp frame0
	subi XL, -80			//Sonst, wenn Bit1 = 0 wird Bild 1 angezeit
	sbrc r16, 0
	subi XL, -80			//Sonst, wird Bild 2 angezeigt (=LSB)
frame0:
startframe:
	inc XH
	cbi _SFR_IO_ADDR(PORTD), FLM

	ld r16, X+				// 320 bits ausgeben
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+

	in r16, _SFR_IO_ADDR(TCCR1A)			//Disable HW-LP for next Interrput
	andi r16, ~((1<<COM1A1)|(1<<COM1A0))
	out _SFR_IO_ADDR(TCCR1A), r16

	sts XsaveL, XL
	sts XsaveH, XH
	lds r16, WriteRamPage					//Restore Ram Page
	out _SFR_IO_ADDR(PORTB), r16

	pop XH
	pop XL
	pop r16
	out _SFR_IO_ADDR(SREG), r16
	pop r16
#ifdef TESTPULSE
	cbi _SFR_IO_ADDR(PORTB), 0
#endif
reti

load2of3:
	ldi r16, 2
	sts IntCnt, r16
	lds XL, XsaveL
	lds XH, XsaveH

	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+


	sts XsaveL, XL
	sts XsaveH, XH
	lds r16, WriteRamPage					//Restore Ram Page
	out _SFR_IO_ADDR(PORTB), r16

	pop XH
	pop XL
	pop r16
	out _SFR_IO_ADDR(SREG), r16
	pop r16
#ifdef TESTPULSE
	cbi _SFR_IO_ADDR(PORTB), 0
#endif
reti

load3of3:
	in r16, _SFR_IO_ADDR(TCCR1A)			//Enable HW-LW again
	ori r16, (1<<COM1A1)
	out _SFR_IO_ADDR(TCCR1A), r16

	clr r16
	sts IntCnt, r16
	lds XL, XsaveL
	lds XH, XsaveH

	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+

	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X+
	ld r16, X

	cpi XH, YMin			// Zeilenzhler berechnen
	brne not_firstline		// Bildende ?
	sbi _SFR_IO_ADDR(PORTD), FLM
	wdr
not_firstline:
	cpi XH, YScan			// VSync ?
	brlo SkipAdRes
	ldi XH, YMin-1			// Adresszhler Reset
SkipAdRes:
	sts YCnt, XH
	lds r16, WriteRamPage					//Restore Ram Page
	out _SFR_IO_ADDR(PORTB), r16
	pop XH
	pop XL
	pop r16
	out _SFR_IO_ADDR(SREG), r16
	pop r16
#ifdef TESTPULSE
	cbi _SFR_IO_ADDR(PORTB), 0
#endif
reti




.global lcd_setpixel		// X: r24:r23
lcd_setpixel:				// Y: r22
	ldi r18, hi8(XSIZEV)	// C: r20
	cpi r24, lo8(XSIZEV)
	cpc r25, r18
	brsh exitbit
	cpi r22, lo8(YSIZE)
	brsh exitbit

	mov r21, r24
	andi r21, 7
	ldi r19, 128
	cpi r21, 0
	breq exitshift
shift:						// r19 = 128>>r21
	lsr r19
	dec r21
	brne shift
exitshift:
	lsr r25
	ror r24
	lsr r25
	ror r24
	mov XL, r24
	mov XH, r22
	subi XH, (-(YMin))
	cli
	sbi _SFR_IO_ADDR(PORTD), CKDIS
	ld r21, X
	cbi _SFR_IO_ADDR(PORTD), CKDIS
	sei
	sbrs r20, 7
	rjmp clrpixel
	or r21, r19
	st X, r21
	rjmp pixel2
clrpixel:
	com r19
	and r21, r19
	st X, r21
	com r19
pixel2:
#ifdef GRAYSCALE
#ifdef GRAY8
	subi XL, -80
	cli
	sbi _SFR_IO_ADDR(PORTD), CKDIS
	ld r21, X
	cbi _SFR_IO_ADDR(PORTD), CKDIS
	sei
	sbrs r20, 6
	rjmp clrpixel2
	or r21, r19
	st X, r21
	rjmp pixel3
clrpixel2:
	com r19
	and r21, r19
	st X, r21
	com r19
pixel3:
	subi XL, -80
	cli
	sbi _SFR_IO_ADDR(PORTD), CKDIS
	ld r21, X
	cbi _SFR_IO_ADDR(PORTD), CKDIS
	sei
	sbrs r20, 5
	rjmp clrpixel3
	or r21, r19
	st X, r21
	rjmp exitbit
clrpixel3:
	com r19
	and r21, r19
	st X, r21
	com r19
#else
	ori XL, 128
	cli
	sbi _SFR_IO_ADDR(PORTD), CKDIS
	ld r21, X
	cbi _SFR_IO_ADDR(PORTD), CKDIS
	sei
	sbrs r20, 6
	rjmp clrpixel2
	or r21, r19
	st X, r21
	rjmp exitbit
clrpixel2:
	com r19
	and r21, r19
	st X, r21
	com r19
#endif
#endif
exitbit:
ret

.global lcd_writebyte		// X: r24
lcd_writebyte:				// Y: r22
							// DATA: r20
	cpi r24, (XSIZEV/8)
	brsh exitbyte
	cpi r22, lo8(YSIZE)
	brsh exitbyte
	mov XL, r24
	lsl XL
	mov XH, r22	
	subi XH, (-(YMin))
	st X,r20
#ifdef GRAYSCALE
#ifdef GRAY8
	subi XL, -80
	st X, r20
	subi XL, -80
	st X, r20
#else
	ori XL, 128
	st X,r20
#endif
#endif
exitbyte:
	ret


#ifdef GRAYSCALE
.global lcd_writebyteg		// X: r24
lcd_writebyteg:				// Y: r22
							// DATA: r20
	cpi r24, (XSIZEV/4)
	brsh exitbyte2
	cpi r22, lo8(YSIZE)
	brsh exitbyte2
	mov XL, r24
	mov XH, r22	
	subi XH, (-(YMin))
	clr r21
	clr r22
	rol r20
	rol r21
	rol r20
	rol r22
	rol r20
	rol r21
	rol r20
	rol r22
	rol r20
	rol r21
	rol r20
	rol r22
	rol r20
	rol r21
	rol r20
	rol r22
	ldi r23, 240
	sbrs XL, 0
	swap r23
	sbrs XL, 0
	swap r21
	cli
	sbi _SFR_IO_ADDR(PORTD), CKDIS
	ld r20, X
	cbi _SFR_IO_ADDR(PORTD), CKDIS
	sei
	and r20, r23
	or r21, r20
	st X,r21
	sbrs XL, 0
	swap r22
#ifdef GRAY8
	subi XL, -80
#else
	ori XL, 128
#endif
	cli
	sbi _SFR_IO_ADDR(PORTD), CKDIS
	ld r20, X
	cbi _SFR_IO_ADDR(PORTD), CKDIS
	sei
	and r20, r23
	or r22, r20
	st X,r22
#ifdef GRAY8
	subi XL, -80
	cli
	sbi _SFR_IO_ADDR(PORTD), CKDIS
	ld r20, X
	cbi _SFR_IO_ADDR(PORTD), CKDIS
	sei
	and r20, r23
	or r22, r20
	st X,r22
#endif
exitbyte2:
	ret
#endif

#ifdef GRAY8
.global lcd_writebyteg8		// X: r24, xs:r22
lcd_writebyteg8:			// Y: r20, ys:r18

	mov r25, r24			//Rechte Grenze vom Bild prfen
	add r25, r22
	cpi r25, (XSIZEV/8)
	brlo noexit1
	rjmp exitbyte8
noexit1:
	mov r21, r20			//Untere Grenze vom Bild prfen
	add r21, r18
	cpi r22, lo8(YSIZE)
	brlo noexit2
	rjmp exitbyte8
noexit2:

	add r18, r20	//y-schleifen Maximum
	subi r18, (-(YMin))
	mov XH, r20		//y-schleifen zhler (Offset+Min)
	subi XH, (-(YMin))

	add r22, r24	//x-schleife maximum
	lsl r22
	subi r22, -160
	mov XL, r24		//x-schleife Zhler
	lsl XL
	subi XL, -160
	mov r21,XL		//backup anlegen

	cbi _SFR_IO_ADDR(PORTD), 2	//Ready to receive Data

lcd_writebyte8loop:
lcd_writebyteg8waitforFirstByte:
	sbis _SFR_IO_ADDR(UCSRA), RXC
	rjmp lcd_writebyteg8waitforFirstByte
	in r25, _SFR_IO_ADDR(UDR)
	subi XL, 160
	st X,  r25
	subi XL, -80

lcd_writebyteg8waitforSecondByte:
	sbis _SFR_IO_ADDR(UCSRA),RXC
	rjmp lcd_writebyteg8waitforSecondByte
	in r30, _SFR_IO_ADDR(UDR)
	st X+, r30
	subi XL, -80

lcd_writebyteg8waitforThirdByte:
	sbis _SFR_IO_ADDR(UCSRA),RXC
	rjmp lcd_writebyteg8waitforThirdByte
	in r31, _SFR_IO_ADDR(UDR)
	st X+, r31

	cpse XL, r22			//X-schleife
	rjmp lcd_writebyte8loop
	mov XL, r21
	inc XH					//Y-schleife
	cpse XH, r18
	rjmp lcd_writebyte8loop
exitbyte8:
	sbi _SFR_IO_ADDR(PORTD), 2	//No More Data

	ret
#endif


.global lcd_writebyteex		// X: r24
lcd_writebyteex:			// Y: r22
	cpi r24, (XSIZEV/8)		// DATA: r20
	brsh exitbx				// TC: r18				
	cpi r22, lo8(YSIZE)		// BC: r16
	brsh exitbx
	lsl r24
	mov XH, r22	
	subi XH, (-(YMin))
	mov r25, r16
	and r25, r18			// Bits die auf jedenfall gesetzt werden
	or r18, r16				// Bits die auf nie gesetzt werden
	mov r22, r20
	mov XL, r24
	sbrc r16, 7				// Wenn Hintergrund an: Bits invertieren (eventuell unntig, aber auf keinen Fall verkehrt)
	com r20
	sbrs r18, 7				// Wenn nichts an: Bits lschen
	clr r20
	sbrc r25, 7				// Wenn beides an: Bits setzen
	ser r20
	st X,r20
#ifdef GRAYSCALE

#ifdef GRAY8
	mov r20, r22
	subi XL, -80
	sbrc r16, 6				// Wenn Hintergrund an: Bits invertieren (eventuell unntig, aber auf keinen Fall verkehrt)
	com r22
	sbrs r18, 6				// Wenn nichts an: Bits lschen
	clr r22
	sbrc r25, 6				// Wenn beides an: Bits setzen
	ser r22
	st X,r22

	subi XL, -80
	sbrc r16, 5				// Wenn Hintergrund an: Bits invertieren (eventuell unntig, aber auf keinen Fall verkehrt)
	com r20
	sbrs r18, 5				// Wenn nichts an: Bits lschen
	clr r20
	sbrc r25, 5				// Wenn beides an: Bits setzen
	ser r20
	st X,r20
#else

	ori XL, 128
	sbrc r16, 6				// Wenn Hintergrund an: Bits invertieren (eventuell unntig, aber auf keinen Fall verkehrt)
	com r22
	sbrs r18, 6				// Wenn nichts an: Bits lschen
	clr r22
	sbrc r25, 6				// Wenn beides an: Bits setzen
	ser r22
	st X,r22
#endif
#endif
exitbx:
ret

.global lcd_writechar		// X: r24
lcd_writechar:				// Y: r22
	cpi r24, (XSIZEV/8)		// C: r20
	brsh exitchar			// TC: r18				
	cpi r22, lo8(YSIZE)		// BC: r16
	brsh exitchar
	mov ZL, r20	
	ldi ZH, TEXT_Y
	mul ZL, ZH
	movw ZL, r0
	subi ZL, lo8(-(font))
	sbci ZH, hi8(-(font))
	ldi r21, TEXT_Y
	lsl r24
	mov XH, r22	
	subi XH, (-(YMin))
	mov r25, r16
	and r25, r18			// Bits die auf jedenfall gesetzt werden
	or r18, r16				// Bits die auf nie gesetzt werden
wchar:
	lpm r20, Z+
	mov r22, r20
	mov XL, r24
	sbrc r16, 7				// Wenn Hintergrund an: Bits invertieren (eventuell unntig, aber auf keinen Fall verkehrt)
	com r20
	sbrs r18, 7				// Wenn nichts an: Bits lschen
	clr r20
	sbrc r25, 7				// Wenn beides an: Bits setzen
	ser r20
	st X,r20
#ifdef GRAYSCALE
#ifdef GRAY8
	mov r20, r22
	subi XL, -80
	sbrc r16, 6				// Wenn Hintergrund an: Bits invertieren (eventuell unntig, aber auf keinen Fall verkehrt)
	com r22
	sbrs r18, 6				// Wenn nichts an: Bits lschen
	clr r22
	sbrc r25, 6				// Wenn beides an: Bits setzen
	ser r22
	st X,r22

	subi XL, -80
	sbrc r16, 5				// Wenn Hintergrund an: Bits invertieren (eventuell unntig, aber auf keinen Fall verkehrt)
	com r20
	sbrs r18, 5				// Wenn nichts an: Bits lschen
	clr r20
	sbrc r25, 5				// Wenn beides an: Bits setzen
	ser r20
	st X,r20
#else
	ori XL, 128
	sbrc r16, 6				// Wenn Hintergrund an: Bits invertieren (eventuell unntig, aber auf keinen Fall verkehrt)
	com r22
	sbrs r18, 6				// Wenn nichts an: Bits lschen
	clr r22
	sbrc r25, 6				// Wenn beides an: Bits setzen
	ser r22
	st X,r22
#endif
#endif
	inc XH					// Zeilen Adresse ++
	dec r21
	brne wchar
	clr r1
exitchar:
ret
